<!-- Nav -->
<%- include('partials/nav', {active: "dashboard"}); %>

<div class="container-fluid">
    <div class="row d-flex d-md-block flex-nowrap wrapper">
        <main class="col-12 float-left col px-5 px-md-3 py-3 main">
            <h1 class="display-3 hidden-xs-down">
                Dashboard
            </h1>
            <% include ./partials/messages %>
            <div class="my-3 p-3 bg-white rounded shadow-sm">
                <h6 class="border-bottom border-gray pb-2 mb-0">Recent Train Request</h6>
                <div class="table-responsive">
                    <table class="table table-striped table-hover">
                        <thead class="thead-dark">
                            <tr>
                                <th scope="col">#</th>
                                <th scope="col">Train ID</th>
                                <th scope="col">Location</th>
                                <th scope="col">Current</th>
                                <th scope="col">Next</th>
                                <th scope="col" class="w-operations-btn">Operation</th>
                            </tr>
                        </thead>
                        <tbody>
                            <% for(var i=0; i < trains.length; i++) { %>
                            <tr id="train-<%= trains[i].jobid %>">
                                <th scope="row"><%= i+1 %></th>
                                <td class="break-word w-50vw font-weight-bold"><%= trains[i].trainclassid %></td>
                                <td class="break-word w-30vw"><%= trains[i].trainstoragelocation %></td>
                                <td><%= trains[i].currentstation %></td>
                                <td><%= trains[i].nextstation %></td>
                                <td id="buttons-td-<%= trains[i].jobid %>">
                                    <a href="<%='/dashboard/reject?jobid='+trains[i].jobid%>" class="btn btn-danger float-right my-2 my-sm-0 btn-block">Rejection</a>
                                    
                                    <button onclick="pullTrain('<%= JSON.stringify(trains[i]) %>')" 
                                        class="btn btn-primary float-right my-2 my-sm-0 btn-block">Pull Image</button>    
                                </td>
                                <td id="pulling-status-td-<%= trains[i].jobid %>" class="d-none">

                                    <div class="fa-3x text-center">
                                        <i class="fas fa-spinner fa-pulse" id="pulse-icon-<%= trains[i].jobid %>"></i>
                                        <i class="fas fa-check d-none" style="color:green" id="check-icon-<%= trains[i].jobid %>"></i>
                                    </div>

                                </td>
                            </tr>
                            <tr id="pulling-logs-tr-<%= trains[i].jobid %>" class="d-none">
                                <td colspan="6">
                                    <pre id="pulling-logs-pre-<%= trains[i].jobid %>" style="font-size: 0.85vw; max-height: 100px;overflow-y: auto;"></pre>
                                </td>
                            </tr>
                            <% } %>
                        </tbody>
                    </table>
                </div>
            </div>

        </main>
    </div>
</div>

<script>

    function modeToggle(mode, train) {

        //0 init 1 pulling 2 complete

        if (mode === 0) {//init

            //hide logs
            const trElm = document.getElementById(`pulling-logs-tr-${train.jobid}`);
            trElm.classList.add("d-none");
            //unhide buttons
            const buttonsTdElm = document.getElementById(`buttons-td-${train.jobid}`);
            buttonsTdElm.classList.remove("d-none");
            //hide status icon
            const statusTdElm = document.getElementById(`pulling-status-td-${train.jobid}`);
            statusTdElm.classList.add("d-none");
        }

        else if (mode === 1) {//pulling

            //unhide logs
            const trElm = document.getElementById(`pulling-logs-tr-${train.jobid}`);
            trElm.classList.remove("d-none");
            //hide buttons
            const buttonsTdElm = document.getElementById(`buttons-td-${train.jobid}`);
            buttonsTdElm.classList.add("d-none");
            //unhide status
            const statusTdElm = document.getElementById(`pulling-status-td-${train.jobid}`);
            statusTdElm.classList.remove("d-none");

        }
        else if (mode === 2) {//complete

            //show check icon
            const pulseIconElm = document.getElementById(`pulse-icon-${train.jobid}`);
            pulseIconElm.classList.add("d-none");
            const checkIconElm = document.getElementById(`check-icon-${train.jobid}`);
            checkIconElm.classList.remove("d-none");
            //flash train row
            const trElm = document.getElementById(`train-${train.jobid}`);
            trElm.classList.add("success_flash");
        }

    }

    function pullTrain(train) {

        train = JSON.parse(train);
        console.log(train);

        //pulling
        modeToggle(1, train)

        const url = `/docker/image/pull?jobid=${train.jobid}&trainstoragelocation=${train.trainstoragelocation}&trainclassid=${train.trainclassid}&currentstation=${train.currentstation}&nextstation=${train.nextstation}`;
        const regex = /\\u([\d\w]{4})/gi;

        var xhr = new XMLHttpRequest()
        xhr.open("GET", url, true)

        xhr.onerror = function (e) {
            console.log(e);
            alert("Error");
        }
        xhr.onprogress = function (e) {
            console.log(e);
            const element = document.getElementById(`pulling-logs-pre-${train.jobid}`);
            const logs = xhr.responseText.replace(regex, function (match, grp) {
                return String.fromCharCode(parseInt(grp, 16));
            });
            element.innerText += logs;
            element.scrollTop = element.scrollHeight;
            console.log(logs);
        }
        xhr.onloadend = function (e) {
            console.log(e);

            if (e.target.status === 200) {

                //complete
                modeToggle(2, train);
                window.location.replace("/dashboard/images");
            }
            else {

                if (e.target.statusText)
                    alert(e.target.statusText);

                //init    
                modeToggle(0, train)
            }
        }
        xhr.send();
    }

</script>